<%
Class C_User
	
	'--- Read-only Properties --------------------

	Public Property Get FirstName()
		FirstName = Session("FirstName")
	End Property

	Public Property Get LastName()
		LastName = Session("LastName")
	End Property

	Public Property Get Honorific()
		Honorific = Session("Honorific")
	End Property

	Public Property Get FullName()
		FullName = Session("FirstName") & " " & Session("LastName")
	End Property

	Public Property Get NameAndTitle()
		NameAndTitle = Session("Honorific") & " " & Session("FirstName") & " " & Session("LastName")
	End Property

	Public Property Get Email()
		Email = Session("Email")
	End Property

	Public Property Get UserID()
		UserID = Session("UserID")
	End Property

	Public Property Get UserType()
		UserType = Session("UserType")
	End Property

	Public Property Get PrevLogonDate()
		PrevLogonDate = Session("PrevLogonDate")
	End Property

	Public Property Get DaysSincePrevLogon()
		DaysSincePrevLogon = DateDiff("d", Session("PrevLogonDate"), Date() )
	End Property
	
	

	'--- Read/Write Properties --------------------

	Public Property Let ActivePatientID(ByVal vData)
		Session("ActivePatientID") = CLng( vData )
	End Property

	Public Property Get ActivePatientID()
		ActivePatientID = Session("ActivePatientID")
	End Property
	
	

	'--- Mix-and-match properties -----------------

	Public Property Get ReverseName()
		'returns "Smith, Pat" in one step...
		ReverseName = Session("LastName") & ", " & Session("FirstName")
	End Property

	Public Property Get Initials()
		'returns Pat Smith's initials: "P.S."
		Initials = Left(Session("FirstName"), 1) & "." & _   
				  Left(Session("LastName"), 1) & "." 
	End Property
	
	
	
	'--- Permission properties --------------------
	
	Public Property Get CanReadWrite()
		If InStr( Session("ForumPermissions"), "\crw\") = 0 Then 
			CanReadWrite = False
		Else
			CanReadWrite = True
		End If
	End Property
	
	
	Public Property Get CanWriteToReadOnly()
		If InStr( Session("ForumPermissions"), "\cwro\") = 0 Then 
			CanWriteToReadOnly = False
		Else
			CanWriteToReadOnly = True
		End If
	End Property
	
	
	Public Property Get CanAdminForums()
		If InStr( Session("ForumPermissions"), "\cadf\") = 0 Then 
			CanAdminForums = False
		Else
			CanAdminForums = True
		End If
	End Property
	
	
	Public Property Get CanAdminUsers()
		If InStr( Session("ForumPermissions"), "\cadu\") = 0 Then 
			CanAdminUsers = False
		Else
			CanAdminUsers = True
		End If
	End Property

	
	
	'--- Additional stuff, not in the article ------------
	
	'For debugging purposes, I found it helpful to provide a 
	'method that would dump out all the properties at once, so
	'that I could review on-screen what all the values were.
	'Nothing too clever about the code.
	
	Sub DropAllValues()
		
		'Uses the "Drop()" function, which is included
		'and described below. Feel free to steal it!
		
		Drop "<h2>Current C_User values</h2>"
		
		Drop "<pre>"
		Drop ".FirstName=" & FirstName()
		Drop ".LastName=" & LastName()
		Drop ".Honorific=" & Honorific()
		Drop ".FullName=" & FullName()
		Drop ".NameAndTitle=" & NameAndTitle()
		Drop ".ReverseName=" & ReverseName()
		Drop ".Initials=" & Initials()
		
		Drop ".Email=" & Email()
		Drop ".UserID=" & UserID()
		Drop ".UserType=" & UserType()
		
		Drop ".PrevLogonDate=" & PrevLogonDate()
		Drop ".DaysSincePrevLogon=" & DaysSincePrevLogon()
		
		Drop ".ActivePatientID=" & ActivePatientID()
		
		Drop ".CanReadWrite=" & CanReadWrite()
		Drop ".CanWriteToReadOnly=" & CanWriteToReadOnly()
		Drop ".CanAdminForums=" & CanAdminForums()
		Drop ".CanAdminUsers=" & CanAdminUsers()
		
		Drop "</pre>"
		
	
	End Sub
	
	
	
	
	Private Sub Drop(ByVal txt)
		'A private function (unavailable outside this class file)
		'that simply replicates Response.Write function, but puts
		'a line-break after it. Makes for more tidy HTML.
		
		Response.Write txt & vbCrLf
		
	End Sub
	
	
	Public Sub KillObject()
	
		'This isn't mentioned in the article, but is useful.
		'Sometimes you want to set all the values to nothing,
		'so that you can start the object from scratch.
		'Don't use this version in your production code!
		
		Session("FirstName") = Null
		Session("LastName") = Null
		Session("Honorific") = Null
		Session("Email") = Null
		Session("UserID") = Null
		Session("UserType") = Null
		Session("PrevLogonDate") = Null
		Session("ActivePatientID") = Null
		Session("ForumPermissions") = Null
	
	End Sub
	
	
	
	
	Sub Class_Initialize()
	
		'Put any code here that you want to run when
		'this object is first instantiated.
		
		'Make sure there's a backslash at the start and end of the 
		'Session("ForumPermissions") variable:
		
		Session("ForumPermissions") = "\" & Session("ForumPermissions") & "\"
	

	End Sub
	
	
	
	Sub Class_Terminate()
	
		'Put any code here that you want to run when
		'this object is set to Nothing or goes out
		'of scope.  
		'
		'Actually, it's good practice to explicitly
		'set the object to Nothing, because this Sub 
		'doesn't always run when the page terminates.
	
	
	End Sub
	
	
End Class

%>
